<#-- 按类型绘制 -->
<#macro renderByDetailType panelDetail view>
    <#if panelDetail.getItemType()?? && panelDetail.getItemType() == "CONTAINER">
    <#-- 边缘布局 -->
    <#if panelDetail.getPSLayout().getLayout()?? && panelDetail.getPSLayout().getLayout() == "BORDER" >
    <app-scroll-container name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">
    <#if panelDetail.getPSPanelItems()??>
        <#list panelDetail.getPSPanelItems() as panelItem>
        <template #${panelItem.getName()}>
        <@renderByDetailType panelItem view />
        </template>
        </#list>
    </#if>
    </app-scroll-container>
    <#-- SIMPLEFLEX布局(栅格布局) -->
    <#elseif panelDetail.getPSLayout().getLayout()?? && panelDetail.getPSLayout().getLayout() == "SIMPLEFLEX" >
    <app-simpleflex-container name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">
     <#if panelDetail.getPSPanelItems()??>
        <#list panelDetail.getPSPanelItems() as panelItem>
        <template #${panelItem.getName()}>
        <@renderByDetailType panelItem view />
        </template>
        </#list>
    </#if>
    </app-simpleflex-container>
    <#else>
    <app-standard-container name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">
     <#if panelDetail.getPSPanelItems()??>
        <#list panelDetail.getPSPanelItems() as panelItem>
        <template #${panelItem.getName()}>
        <@renderByDetailType panelItem view />
        </template>
        </#list>
    </#if>
    </app-standard-container>
    </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "TABPAGE">
    <app-tab-page name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">
        <#if panelDetail.getPSPanelItems?? && panelDetail.getPSPanelItems()??>
            <#list panelDetail.getPSPanelItems() as panelItem>
        <template #${panelItem.getName()}>
            <@renderByDetailType panelItem view />
        </template>
            </#list>
        </#if>
    </app-tab-page>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "TABPANEL">
    <app-tab-panel name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">
        <#if panelDetail.getPSPanelTabPages?? && panelDetail.getPSPanelTabPages()??>
            <#list panelDetail.getPSPanelTabPages() as tabPage>
        <template #${tabPage.getName()}>
            <@renderByDetailType tabPage view />
        </template>
            </#list>
        </#if>
    </app-tab-panel>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "FIELD">
        <#if panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_USERID">
        <app-login-input class="app-login-user" name="${panelDetail.getName()}" :model="layoutModelDetails.${panelDetail.getName()}" :value="layoutData.${panelDetail.getName()}" defaultIcon="ios-contact" @valueChange="handleValueChange" />
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_PASSWORD">
        <app-login-input class="app-login-password" name="${panelDetail.getName()}" :model="layoutModelDetails.${panelDetail.getName()}" :value="layoutData.${panelDetail.getName()}" defaultIcon="ios-key" @valueChange="handleValueChange" />
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_ORGPICK">
        <app-login-org name="${panelDetail.getName()}" :model="layoutModelDetails.${panelDetail.getName()}" :value="layoutData.${panelDetail.getName()}" @valueChange="handleValueChange" />
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_VERIFICATIONCODE">
        <app-login-note-verify />
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_LOGINMSG">
        <app-login-message />
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "APP_APPTITLE">
        <app-preset-title name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails"/>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "VIEW_PAGECAPTION">
        <app-preset-caption name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">${view.caption}</app-preset-caption>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_TEXT_DYNAMIC">
        <app-preset-text name="${panelDetail.getName()}" :value="layoutData.${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails"/>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_SWITCH">
        <app-preset-switch :layoutModelDetails="layoutModelDetails" :value="layoutData.${panelDetail.getName()}" name="${panelDetail.getName()}" @valueChange="handleValueChange"/>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_QRCODE">
        <app-preset-qrcode :layoutModelDetails="layoutModelDetails" :value="layoutData.${panelDetail.getName()}" name="${panelDetail.getName()}"/>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_TEXTBOX">
        <app-preset-text-input :layoutModelDetails="layoutModelDetails" :value="layoutData.${panelDetail.getName()}" name="${panelDetail.getName()}" @valueChange="handleValueChange"/>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_ORGPICK">
            <app-index-org-select name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails"></app-index-org-select>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_IMAGE">
            <app-field-image-dynamic 
            name="${panelDetail.getName()}" 
            <#if panelDetail.getPSEditor().getCssStyle?? && panelDetail.getPSEditor().getCssStyle()??>cssStyle="${panelDetail.getPSEditor().getCssStyle()}"</#if> 
            <#if panelDetail.getPSEditor().getPSSysCss?? && panelDetail.getPSEditor().getPSSysCss()??>cssClass="${panelDetail.getPSEditor().getPSSysCss()}"</#if> 
            :value="layoutData['${panelDetail.getName()}']">
            </app-field-image-dynamic>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_CAROUSEL">
            <app-rawitem-carousel 
                :data="layoutData"
                name="${panelDetail.getName()}"
                type="FIELD_CAROUSEL"
                :value="layoutData['${panelDetail.getName()}']"
                <#if panelDetail.getPSEditor().getCssStyle?? && panelDetail.getPSEditor().getCssStyle()??>cssStyle="${panelDetail.getPSEditor().getCssStyle()}"</#if> 
                <#if panelDetail.getPSEditor().getPSSysCss?? && panelDetail.getPSEditor().getPSSysCss()??>cssClass="${panelDetail.getPSEditor().getPSSysCss()}"</#if>>
            </app-rawitem-carousel>
        <#else>
        <span>属性项</span>
        </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "RAWITEM">
        <#if panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()??>
        <#assign rawdetail = panelDetail.getPSRawItem()/>
        <#if  rawdetail.getPredefinedType?? && rawdetail.getPredefinedType()?? && rawdetail.getPredefinedType() == "STATIC_IMAGE">
        <app-rawitem-image
            <#if rawdetail.getCssStyle?? && rawdetail.getCssStyle()??>
            cssStyle="${ rawdetail.getCssStyle() }"
            </#if>
            <#if rawdetail.getPSSysImage?? && rawdetail.getPSSysImage()?? && rawdetail.getPSSysImage().getImagePath?? && rawdetail.getPSSysImage().getImagePath()??>
            imgUrl="${ rawdetail.getPSSysImage().getImagePath() }"
            </#if>
            <#if rawdetail.getPSSysImage?? && rawdetail.getPSSysImage()?? && rawdetail.getPSSysImage().getCssClass?? && rawdetail.getPSSysImage().getCssClass()??>
            imageClass="${ rawdetail.getPSSysImage().getCssClass() }"
            </#if>
            <#if rawdetail.getPSSysCss?? && rawdetail.getPSSysCss()??>
            cssClass="${ rawdetail.getPSSysCss() }"
            </#if>>
            </app-rawitem-image>
        <#elseif rawdetail.getPredefinedType?? && rawdetail.getPredefinedType()?? && rawdetail.getPredefinedType() == "STATIC_CAROUSEL">
        <app-rawitem-carousel
            type="STATIC_CAROUSEL"
            name="${panelDetail.getName()}"
            :value="[]"
            <#if rawdetail.getCssStyle?? && rawdetail.getCssStyle()??>
            cssStyle="${ rawdetail.getCssStyle() }"
            </#if>
            <#if rawdetail.getPSSysCss?? && rawdetail.getPSSysCss()??>
            cssClass="${ rawdetail.getPSSysCss() }"
            </#if>
            :data="layoutData"
        >
        </app-rawitem-carousel>
        <#elseif rawdetail.getPredefinedType?? && rawdetail.getPredefinedType()?? && rawdetail.getPredefinedType() == "STATIC_VIDEOPLAYER">
        <app-rawitem-video :videoParmas="[]"/>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && panelDetail.getPSRawItem().getPredefinedType() == 'NAV_POS'>
            <app-nav-pos name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails" :navData="layoutModelDetails['${panelDetail.getName()}'].navData"></app-nav-pos>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && panelDetail.getPSRawItem().getPredefinedType() == 'NAV_BREADCRUMB'>
            <app-index-nav-breadcrumb name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails"<#if view?? && view.getViewType?? && view.getViewType() == 'APPINDEXVIEW'> indexViewTag="${srffilepath2(view.getCodeName())}"</#if>></app-index-nav-breadcrumb>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && (panelDetail.getPSRawItem().getPredefinedType() == 'STATIC_LABEL' || panelDetail.getPSRawItem().getPredefinedType() == 'STATIC_TEXT')>
        <app-preset-text name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails"/>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && panelDetail.getPSRawItem().getPredefinedType() == 'NAV_TABS'>
            <app-index-nav-tabs name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails"></app-index-nav-tabs>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && panelDetail.getPSRawItem().getPredefinedType() == 'AUTH_USERINFO'>
            <app-index-user-info name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails"></app-index-user-info>
        </#if>
     </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "BUTTON">
        <#if panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()?? && panelDetail.getPSUIAction().getPredefinedType?? && panelDetail.getPSUIAction().getPredefinedType()?? && panelDetail.getPSUIAction().getPredefinedType() == "APP_LOGIN">
        <app-login-button class="app-login-button" name="${panelDetail.getName()}"  :model="layoutModelDetails.${panelDetail.getName()}" defaultStyle='primary' @itemClick="handleButtonClick" />
        <#elseif panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()?? && panelDetail.getPSUIAction().getPredefinedType?? && panelDetail.getPSUIAction().getPredefinedType()?? && panelDetail.getPSUIAction().getPredefinedType() == "APP_REGISTER">
        <app-login-button class="app-register-button" name="${panelDetail.getName()}"  :model="layoutModelDetails.${panelDetail.getName()}" defaultStyle='success' @itemClick="handleButtonClick" />
        <#elseif panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()?? && panelDetail.getPSUIAction().getPredefinedType?? && panelDetail.getPSUIAction().getPredefinedType()?? && panelDetail.getPSUIAction().getPredefinedType() == "DATA_CANCELCHANGES">
        <app-login-button class="app-reset-button" name="${panelDetail.getName()}"  :model="layoutModelDetails.${panelDetail.getName()}" defaultStyle='success' @itemClick="handleButtonClick" />
        <#elseif panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()?? && panelDetail.getPSUIAction().getPredefinedType?? && panelDetail.getPSUIAction().getPredefinedType()?? && panelDetail.getPSUIAction().getPredefinedType() == "APP_LOGOUT">
        <app-login-button class="app-logout-button" name="${panelDetail.getName()}"  :model="layoutModelDetails.${panelDetail.getName()}" @itemClick="handleButtonClick" />
        <#elseif panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()??>
        <app-preset-button
            name="${panelDetail.getName()}" 
            :layoutModelDetails="layoutModelDetails"
            <#if panelDetail.getCaptionItemName?? && panelDetail.getCaptionItemName() != ''>
            :caption="layoutData.${panelDetail.getCaptionItemName()}"
            :tooltip="layoutData.${panelDetail.getCaptionItemName()}"
            <#else>
            caption="${panelDetail.getPSUIAction().getCaption()}"
            tooltip="${panelDetail.getPSUIAction().getTooltip()}"
            </#if>
            @itemClick="handleButtonClick">
        </app-preset-button>
        <#else>
        <span>按钮</span>
        </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "CTRLPOS">
            <app-ctrl-pos name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">
        <#if view?? && view.hasPSControl?? && view.hasPSControl(panelDetail.getName())>
                ${P.getCtrlCode(panelDetail.getName(), 'CONTROL.html').code}
        <#else>
                <span>部件占位${panelDetail.getName()}</span>
        </#if>
            </app-ctrl-pos>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "USERCONTROL">
        <#if panelDetail.getPredefinedType?? && panelDetail.getPredefinedType()?? && panelDetail.getPredefinedType() == "AUTH_CAPTCHA">
        <app-login-captcha name="${panelDetail.getName()}" :model="layoutModelDetails.${panelDetail.getName()}" :value="layoutData.${panelDetail.getName()}" @valueChange="handleValueChange" />
        <#elseif panelDetail.getPredefinedType?? && panelDetail.getPredefinedType()?? && panelDetail.getPredefinedType() == "AUTH_SSO">
        <app-login-third />
        <#else>
        <span>用户自定义控件</span>
        </#if>
    <#else>
    <span>${panelDetail.getItemType()}暂未支持</span>
    </#if>
</#macro>